/**
  *  \file planetscentral/dbclient/fileclient.h
  *  \brief Client for c2file
  */
#ifndef C2SERVER_PLANETSCENTRAL_DBCLIENT_FILECLIENT_H
#define C2SERVER_PLANETSCENTRAL_DBCLIENT_FILECLIENT_H

#include "cpluslib/string.h"

class DbClient;
class IntValue;

/** Client for c2file. */
class FileClient {
 public:
    FileClient(DbClient& file);

    void setUserPermissions(string_t user);
    void setRootPermissions();
    void setFilePermissions(string_t dir, string_t player, string_t perms);

    void createDirectory(string_t name);
    void createDirectoryTree(string_t name);
    void removeDirectory(string_t name);
    void forgetDirectory(string_t name);

    string_t getFile(string_t name);
    void putFile(string_t name, string_t content);
    void removeFile(string_t name);

    void setProperty(string_t dir, string_t name, string_t value);
    void setProperty(string_t dir, string_t name, int32_t value);

    string_t getStringProperty(string_t dir, string_t name);
    int32_t getIntProperty(string_t dir, string_t name);

    IntValue* getDirectoryContent(string_t dir);

 private:
    DbClient& file;
};

#endif
